// Filename: Example1.cpp
//
// SpinCore Technologies, Inc.
// October 2002
// http://www.spincore.com
//
// The following program code uses C Functions from 'pbdfuncs' to
// generate and execute a pulse sequence on the PulseBlasterDDS board.

// Be sure to include the the header file (pbdfuncs.h) and source 
// file (pbdfuncs.cpp) in the working directory of your C compiler .

#include <stdio.h>
#include "pbdfuncs.h"
#include "pbdfuncs.cpp"

void main()
{
	int start;
	set_clock(100); // 100 MHz reference clock frequency

	start_programming(FREQ_REGS);
	set_freq(1.012); // 1.012 MHz in 0th frequency register
	
start_programming(TX_PHASE_REGS);
	set_phase(0); // Tx phase value set to 0 degrees (in 0th phase register)
		
	start_programming(RX_PHASE_REGS);
	set_phase(180); // Rx set to 180 degrees out of phase
		
	start_programming(PULSE_PROGRAM);

	// Instruction 0 - Continue to next instruction in 10.0 us
	start = pb_inst(0,0,TX_ANALOG_ON,0,RX_ANALOG_ON,0x3FF,CONTINUE,0,10.0*us);

	// Instruction 1 - Branch to "start" (Instruction 0) in 1 ms
	pb_inst(0,0,TX_ANALOG_OFF,0,RX_ANALOG_ON,0x0,BRANCH,start,1*ms);

	stop_programming();

	start_pb(); //the pulse program  will start
}
